<template>
    <div> 

        <div class="divBuscador">
        <div>
            <v-text-field 
            v-model="search" 
            class="buscador" 
            append-icon="mdi-magnify" 
            label="Buscar..." 
            single-line hide-details>
            </v-text-field>
        </div>
        </div>
        <v-data-table
            :search="search" 
            :headers="headers"
            :items="items"
            :page.sync="page" 
            :items-per-page="itemsPerPage" 
            hide-default-footer                      
            item-key="ceco"
            :single-expand = "single"   
            class="tblHallazgos tablaSucursal"
            @page-count="pageCount = $event" 
            >

                <template v-slot:header.totalHallazgos="{header}">
                    <span class="border_1">{{ header.text.toUpperCase() }}</span>
                </template>
                
                <template v-slot:header.porAtender="{header}">
                    <span class="borderN_light_1">{{ header.text.toUpperCase() }}</span>
                </template>

                <template v-slot:header.porAutorizar="{header}">
                    <span class="borderN_light_1">{{ header.text.toUpperCase() }}</span>
                </template>

                <template v-slot:header.rechazadosPorAtender="{header}">
                    <span class="borderR_1">{{ header.text.toUpperCase() }}</span>
                </template>

                <template v-slot:header.atendidos="{header}">
                    <span class="borderV_1">{{ header.text.toUpperCase() }}</span>
                </template>
                

                <template v-slot:item="{ item, expand, isExpanded }">
                    <tr>
                        <td @click="expand(!isExpanded); getFases(item.ceco) " style="width : 25%" ><span class="expandible">{{ item.nombreCeco}}</span></td>
                        <td style="width : 15%">{{ item.totalHallazgos }}</td>
                        <td style="width : 15%">{{ item.porAtender }}</td>
                        <td style="width : 15%">{{ item.porAutorizar }}</td>
                        <td style="width : 15%">{{ item.rechazadosPorAtender }}</td>
                        <td style="width : 15%">{{ item.atendidos }}</td>
                    </tr> 
                </template>


                <template v-slot:expanded-item="{ headers,item }">
                
                    <td :colspan="headers.length" style="padding : 0px; border: 0px ">
                    
                        <template>
                            <v-simple-table >
                                <template v-slot:default>       
                                        <tbody >
                                            <tr style="width : 100%" v-for="fase in fases" :key="fase.fase">              
                                                <td style="width : 25%; background-color: #fff">{{ fase.fase}}</td>
                                                <td style="width : 15%; background-color: #fff">{{ fase.totalHallazgos }}</td>
                                                <td style="width : 15%; background-color: #fff">{{ fase.porAtender }}</td>
                                                <td style="width : 15%; background-color: #fff">{{ fase.porAutorizar }}</td>
                                                <td style="width : 15%; background-color: #fff">{{ fase.rechazadosPorAtender }}</td>
                                                <td style="width : 15%; background-color: #fff">{{ fase.atendidos }}</td>
                                            </tr>
                                        </tbody>
                                </template>
                            </v-simple-table>
                        </template>

                    </td>
                                    
                </template>
        
  
        </v-data-table>

        <div class="text-center pt-2">
        <v-pagination v-model="page" :length="pageCount" class="paginador"></v-pagination>
    </div>

        
    </div>
</template>

<script>
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
export default {
    props : {
        negocio : Object,
        fechaInicio : String,
        fechaFin : String 
    },
    data() {
        return {
            search: "",
            page: 1,
            pageCount: 1,
            itemsPerPage: 10,
            single : true,
            expanded: [],
            headers :[
            
                {
                    text: "Sucursal",
                    value: "nombreCeco",
                    align: 'center',
                    width: "25%"
                },
                {
                    text: "Total de hallazgos",
                    value: "totalHallazgos",
                    align: 'center',
                    width: "15%"
                },
                {
                    text: "Por atender",
                    value: "porAtender",
                    align: 'center',
                    width: "15%"
                },
                {
                    text: "Por Autorizar",
                    value: "porAutorizar",
                    align: 'center',
                    width: "15%"
                },
                {
                    text: "Rechazados ",
                    value: "rechazadosPorAtender",
                    align: 'center',
                    width: "15%"
                },
                {
                    text: "Atendidos",
                    value: "atendidos",
                    align: 'center',
                    width: "15%"
                }
            ],
            items:[
                /*{
                    ceco: "999995",
                    nombreCeco: "TORRE AREA",
                    totalHallazgos: 5,
                    atendidos: 0,
                    porAtender: 0,
                    porAutorizar: 0,
                    rechazadosPorAtender: 0
                }*/],
            fases : [],
        }
    },
    created(){
        this.getTotales();
    },
    methods: {
        expandedItem(value,props){
            this.expanded = [];
            this.expanded.push(value);
        }, 
        getFases(sucursal){

            this.fases =  [];
            
            axiosChecklist
            .get(
                "expansionCoreServices/getConteoHallazgosFase.json?ceco="+
                sucursal+
                "&fechaInicio="+
                this.fechaInicio+
                "&fechaFin=" +
                this.fechaFin
                ,
                {
                    responseType: "json",
                }
            )
            .then((response) => {
                if (response) {
                    if (response.status === 200) {

                    /*var json = {
                        totalGral : 67,
                        porAtender : 82,
                        porAutorizar : 0,
                        rechazados : 0,
                        atendidos: 0, 
                        negocio: "EKT"
                    };
                    this.initData(json)*/
                    this.initDataFases(response.data);
                    }
                }
            })
            .catch((error) => {
                console.log(error);
            })
            .finally(function() {});
        },
        initData(json){

            if(json){
                this.items = json.conteos_by_ceco;
            }

        },
        initDataFases(json){

            if(json){
                this.fases = json.conteos_by_fase;
            }


        },
        getTotales() {
            axiosChecklist
            .get(
                "expansionCoreServices/getConteosCecos.json?negocio="+
                this.negocio.id+
                "&fechaInicio="+
                this.fechaInicio+
                "&fechaFin=" +
                this.fechaFin
                ,
                {
                    responseType: "json",
                }
            )
            .then((response) => {
                if (response) {
                    if (response.status === 200) {

                    /*var json = {
                        totalGral : 67,
                        porAtender : 82,
                        porAutorizar : 0,
                        rechazados : 0,
                        atendidos: 0, 
                        negocio: "EKT"
                    };
                    this.initData(json)*/
                    this.initData(response.data);
                    }
                }
            })
            .catch((error) => {
                console.log(error);
            })
            .finally(function() {});

         /*var json = {
                totalGral : 67,
                porAtender : 82,
                porAutorizar : 10,
                rechazados : 2,
                atendidos: 1, 
                negocio: "EKT"
              };
              this.initData(json)*/

    }

    },
}
</script>

<style >


.expandible{
  color: #ff9600;
  font-family: "AvenirNextLTPro-Medium";
}
.border_1{
    border-bottom:3px solid#5a5854;padding-bottom: 5px   
}
.borderV_1{
    border-bottom:3px solid #67af4a;padding-bottom: 5px  
}
.borderN_light_1{
    border-bottom:3px solid #f19838;padding-bottom: 5px
}
.borderN_1{
    border-bottom:3px solid #ee7c31;padding-bottom: 5px
}
.borderR_1{
    border-bottom:3px solid #ea3425;padding-bottom: 5px
}

.tablaSucursal{
  margin: 0px;
  padding: 0px;
  border: 0px;
  margin-top: 10px;
}

.tablaSucursal th{
  background-color: #fafafa;
}

.tablaSucursal tr {
    background-color:  #f2f2f2;
}

</style>

